(function( $ ) {
	var $booking_wrapper = jQuery('#pmab_booking_wrapper');
	var booking = true;
	// Name can't be blank
	jQuery('form.booking_form').on('click', '#booking_form_send', function(a) {
		var error = false;
		jQuery('form.booking_form input.field_text').each(function() {
			var value = jQuery(this).val();
			if( empty(value) ) {
				error = true;
				jQuery(this).css('border','1px solid red');
			} else {
				jQuery(this).css('border','0 none');
			}
		});
		var schedule = jQuery('form.booking_form .available_time input[type=checkbox]:checked').length;
		if(schedule <= 0) {
			error = true;
			jQuery('form.booking_form .available_time p.error').show();
		} else {
			jQuery('form.booking_form .available_time p.error').hide();
		}
		
		var datachecked = jQuery('form.booking_form #booking_form_checked:checked').length;
		if(datachecked <= 0) {
			error = true;
			jQuery('form.booking_form #booking_form_checked_wrapper').css('border','1px solid red');
		} else {
		
		}
		
		if(error) {
			a.preventDefault();
		}
	});
	
	$booking_wrapper.find('form.booking_form .available_time').on('change', 'input[type=checkbox]', function(){
		
		var sc = jQuery('form.booking_form .available_time input[type=checkbox]:checked').length;
		if(sc > 0) {
			var total = parseFloat(sc) * parseFloat(myAjax.price);
			total = total.toFixed(2);
			$booking_wrapper.find('form.booking_form .booking_form_price_total_wrapper span').text(total);
			$booking_wrapper.find('form.booking_form #booking_form_price_total').val(total);
			$booking_wrapper.find('form.booking_form #booking_form_price_qty').val(sc);
		} else {
			$booking_wrapper.find('form.booking_form .booking_form_price_total_wrapper span').text('0.00');
			$booking_wrapper.find('form.booking_form #booking_form_price_total').val('0.00');
			$booking_wrapper.find('form.booking_form #booking_form_price_qty').val(sc);
		}
	});
	$booking_wrapper.find('table.pmab_calendar td').on('click','a.booking_btn', function(a) {
		a.preventDefault();
		var $this = jQuery(this);
		var date = $this.attr('data-href');
		var day = $this.attr('data-day');
		var $cb_wrapper = $booking_wrapper.find('#pmab_create_booking');
		var $preloader = $booking_wrapper.find('#pmab_preloader');
		$cb_wrapper.hide();
		if(booking) {
			booking = false;
			$preloader.show();
			jQuery('body').css({'cursor' : 'wait'});
			var data = {
				action: 'pm_appointment_book_get_schedule',
				pid: myAjax.pid,
				date: date,
				day: day
			};
			jQuery.post(myAjax.ajaxurl, data, function(response) {
				jQuery('body').css({'cursor' : 'auto'});
				var jsonData = JSON.parse(response);
				
				if(jsonData.status == 'success') {
					booking = true;
					$preloader.hide();
					console.log(jsonData);
					$cb_wrapper.find('.available_time').html(jsonData.schedules);
					$cb_wrapper.find('.booking_form_date_wrapper span').text(jsonData.date);
					$cb_wrapper.find('#booking_form_date').val(jsonData.date);
					
					$cb_wrapper.fadeIn(function() {
					});
				} else {
					booking = true;
					$preloader.hide();
					console.log(jsonData.message);
				}
			});
		} else {
			
		}
	});
})( jQuery );

function empty(mixed_var) {
  //  discuss at: http://phpjs.org/functions/empty/
  // original by: Philippe Baumann
  //    input by: Onno Marsman
  //    input by: LH
  //    input by: Stoyan Kyosev (http://www.svest.org/)
  // bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // improved by: Onno Marsman
  // improved by: Francesco
  // improved by: Marc Jansen
  // improved by: Rafal Kukawski
  //   example 1: empty(null);
  //   returns 1: true
  //   example 2: empty(undefined);
  //   returns 2: true
  //   example 3: empty([]);
  //   returns 3: true
  //   example 4: empty({});
  //   returns 4: true
  //   example 5: empty({'aFunc' : function () { alert('humpty'); } });
  //   returns 5: false

  var undef, key, i, len;
  var emptyValues = [undef, null, false, 0, '', '0'];

  for (i = 0, len = emptyValues.length; i < len; i++) {
    if (mixed_var === emptyValues[i]) {
      return true;
    }
  }

  if (typeof mixed_var === 'object') {
    for (key in mixed_var) {
      // TODO: should we check for own properties only?
      //if (mixed_var.hasOwnProperty(key)) {
      return false;
      //}
    }
    return true;
  }

  return false;
}

function isset() {
  //  discuss at: http://phpjs.org/functions/isset/
  // original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // improved by: FremyCompany
  // improved by: Onno Marsman
  // improved by: Rafał Kukawski
  //   example 1: isset( undefined, true);
  //   returns 1: false
  //   example 2: isset( 'Kevin van Zonneveld' );
  //   returns 2: true

  var a = arguments,
    l = a.length,
    i = 0,
    undef;

  if (l === 0) {
    throw new Error('Empty isset');
  }

  while (i !== l) {
    if (a[i] === undef || a[i] === null) {
      return false;
    }
    i++;
  }
  return true;
}