<?php
//pm_appointment_book
//Author Compete
/*
	* functions.php
*/
add_action( 'plugins_loaded', 'pm_appointment_book_load_textdomain' );
function pm_appointment_book_load_textdomain() {
    load_plugin_textdomain( 'pm-appointment-book', false, dirname( plugin_basename( __DIR__ ) ) . '/languages' );
}

/**
 * Flush rewrite rules for custom post type archive on single activation
 *
 * @since    0.0.1
 */
function pm_appointment_book_install() {
	global $wpdb;
	
	pm_appointment_book_post_type_init();
	flush_rewrite_rules();
	
	$table_name = $wpdb->prefix . 'pm_appointment_book';
	//$table_name2 = $wpdb->prefix . 'pm_appointment_book_paypal_payments';

	$sql = "CREATE TABLE {$table_name} (
		id mediumint(9) NOT NULL AUTO_INCREMENT,
		postid bigint(20) NOT NULL,
		booking_date DATE NOT NULL,
		time varchar(10) NOT NULL,
		date datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
		UNIQUE KEY id (id)
	);";

	require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
	dbDelta( $sql );

}

/*
	* pm_appointment_book_deactivate
*/

function pm_appointment_book_deactivate() {

}

/**
 * Register a Author Compete post type.
 *
 * @link http://codex.wordpress.org/Function_Reference/register_post_type
 */
add_action( 'init', 'pm_appointment_book_post_type_init' );
function pm_appointment_book_post_type_init() {
	$labels_appointment_book_calendar = array(
		'name'               => _x( 'Appointment Calendars', 'post type general name', 'pm-appointment-book' ),
		'singular_name'      => _x( 'Appointment Calendar', 'post type singular name', 'pm-appointment-book' ),
		'menu_name'          => _x( 'Appointment Calendars', 'admin menu', 'pm-appointment-book' ),
		'name_admin_bar'     => _x( 'Appointment Calendar', 'add new on admin bar', 'pm-appointment-book' ),
		'add_new'            => _x( 'Add New', 'Appointment Calendar', 'pm-appointment-book' ),
		'add_new_item'       => __( 'Add New Appointment Calendar', 'pm-appointment-book' ),
		'new_item'           => __( 'New Appointment Calendar', 'pm-appointment-book' ),
		'edit_item'          => __( 'Edit Appointment Calendar', 'pm-appointment-book' ),
		'view_item'          => __( 'View Appointment Calendar', 'pm-appointment-book' ),
		'all_items'          => __( 'All Appointment Calendars', 'pm-appointment-book' ),
		'search_items'       => __( 'Search Appointment Calendars', 'pm-appointment-book' ),
		'parent_item_colon'  => __( 'Parent Appointment Calendars:', 'pm-appointment-book' ),
		'not_found'          => __( 'No Appointment Calendars found.', 'pm-appointment-book' ),
		'not_found_in_trash' => __( 'No Appointment Calendars found in Trash.', 'pm-appointment-book' )
	);

	$args_appointment_book_calendar = array(
		'labels'             => $labels_appointment_book_calendar,
		'public'             => true,
		'publicly_queryable' => true,
		'exclude_from_search' => true,
		'show_ui'            => true,
		'show_in_menu'       => true,
		'query_var'          => false,

		'capability_type'    => 'post',
		'has_archive'        => false,
		'hierarchical'       => false,
		'menu_icon'	=>	'dashicons-calendar-alt',
		'menu_position'      => 105,
		'supports'           => array( 'title')
	);
	//Register Appointment
	$labels_appointment_book_appointment = array(
		'name'               => _x( 'Appointments', 'post type general name', 'pm-appointment-book' ),
		'singular_name'      => _x( 'Appointment', 'post type singular name', 'pm-appointment-book' ),
		'menu_name'          => _x( 'Appointments', 'admin menu', 'pm-appointment-book' ),
		'name_admin_bar'     => _x( 'Appointment', 'add new on admin bar', 'pm-appointment-book' ),
		'add_new'            => _x( 'Add New', 'Appointment', 'pm-appointment-book' ),
		'add_new_item'       => __( 'Add New Appointment', 'pm-appointment-book' ),
		'new_item'           => __( 'New Appointment', 'pm-appointment-book' ),
		'edit_item'          => __( 'Edit Appointment', 'pm-appointment-book' ),
		'view_item'          => __( 'View Appointment', 'pm-appointment-book' ),
		'all_items'          => __( 'All Appointments', 'pm-appointment-book' ),
		'search_items'       => __( 'Search Appointments', 'pm-appointment-book' ),
		'parent_item_colon'  => __( 'Parent Appointments:', 'pm-appointment-book' ),
		'not_found'          => __( 'No Appointments found.', 'pm-appointment-book' ),
		'not_found_in_trash' => __( 'No Appointments found in Trash.', 'pm-appointment-book' )
	);

	$args_appointment_book_appointment = array(
		'labels'             => $labels_appointment_book_appointment,
		'public'             => false,
		'publicly_queryable' => false,
		'exclude_from_search' => true,
		'show_ui'            => true,
		'show_in_menu'       => true,
		'query_var'          => false,

		'capability_type'    => 'post',
		'has_archive'        => false,
		'hierarchical'       => false,
		'menu_position'      => 106,
		'menu_icon'	=>	'dashicons-welcome-write-blog',
		'supports'           => array( 'title'),
		'capabilities' => array(
		'create_posts' => false, // Removes support for the "Add New" function ( use 'do_not_allow' instead of false for multisite set ups )
		),
		'map_meta_cap' => true
	);
	
	
	register_post_type( 'calendar', $args_appointment_book_calendar );
	register_post_type( 'pm-appointment', $args_appointment_book_appointment );
	
}

/*
	* Remove Bulk Actions on Appointments
*/
function pm_appointment_book_custom_bulk_actions($actions){
        unset( $actions['edit'] );
        return $actions;
    }
    add_filter('bulk_actions-edit-pm-appointment','pm_appointment_book_custom_bulk_actions');

/**
 * Hide the "Publish" button until a post is ready to be published
 * In this example, we only show the "Publish button" until the post has the "Pending" status
 *
 * @see http://editflow.org/extend/hide-the-publish-button-for-certain-custom-statuses/
 */
function pm_appointment_book_hide_publish_button() {
        $my_post_type = 'pm-appointment';
        global $post;
        if($post->post_type == $my_post_type){
            echo '
                <style type="text/css">
					#save-post,
                    #publishing-action {
                        display:none !important;
                    }
                </style>
            ';
        }
}
add_action('admin_head-post.php', 'pm_appointment_book_hide_publish_button');
add_action('admin_head-post-new.php', 'pm_appointment_book_hide_publish_button');
/*
	* pm_appointment_book_days
	* Array of Days
*/

function pm_appointment_book_days() {
	$days = array(
		'sunday' => esc_html(__('Sunday', 'pm-appointment-book')),
		'monday' => esc_html(__('Monday', 'pm-appointment-book')),
		'tuesday' => esc_html(__('Tuesday' ,'pm-appointment-book')),
		'wednesday' => esc_html(__('Wednesday' ,'pm-appointment-book')),
		'thursday' => esc_html(__('Thursday' ,'pm-appointment-book')),
		'friday' => esc_html(__('Friday' ,'pm-appointment-book')),
		'saturday' => esc_html(__('Saturday' ,'pm-appointment-book'))
	);
	
	return $days;
}

/*
	* Register Session to be use for booking
*/

function pm_appointment_book_register_my_session() {
	if( !session_id() ) {
		session_start(); 
	}
}

add_action('init', 'pm_appointment_book_register_my_session');

/*
	* pm_appointment_book_setting_fields
	* Fields for Settings
	* To Email if Required
	'mail_to_name' => array(
		'name' => 'mail_to_name',
		'description' => esc_html(__('Enter to name where you want to send notifications.', 'pm-appointment-book')),
		'field' => 'input',
		'type' => 'text',
		'label' => esc_html(__('Mail "to" name', 'pm-appointment-book')),
		'default' => $blogname,
		'html_after' => '',
		'class' => '',
		'attributes' => '',
		'repeatable' => false,
		'repeatable' => false
	),
*/
function pm_appointment_book_setting_fields(){
	$admin_email = get_option('admin_email');
	$blogname = get_option('blogname');
	$fields = array(
		'general' => array(
			'title' => esc_html(__('General Settings', 'pm-appointment-book')),
			'icon' => 'icon-edit',
			'fields' => array(
				'currency' => array(
					'name' => 'currency',
					'description' => esc_html(__('Enter 3 letter currency code. ', 'pm-appointment-book')). sprintf(__('<a target="_blank" href="%s">Click here</a> for supported currency.', 'pm-appointment-book'),'https://developer.paypal.com/docs/classic/api/currency_codes/'),
					'field' => 'input',
					'type' => 'text',
					'label' => esc_html(__('Currency', 'pm-appointment-book')),
					'default' => 'USD',
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'currency_symbol' => array(
					'name' => 'currency_symbol',
					'description' => esc_html(__('Enter currency Symbol. ', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'text',
					'label' => esc_html(__('Currency Symbol', 'pm-appointment-book')),
					'default' => '$',
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'booking_days_minimun' => array(
					'name' => 'booking_days_minimun',
					'description' => __('Enter minumum day from now for advance booking(ie: 3 means you can only book 3 <strong>days from now</strong> ). Enter 0 for today. ', 'pm-appointment-book'),
					'field' => 'input',
					'type' => 'number',
					'label' => esc_html(__('Minimum booking day', 'pm-appointment-book')),
					'default' => '0',
					'html_after' => '',
					'class' => '',
					'attributes' => 'min="0" ',
					'repeatable' => false,
					'repeatable' => false
				),
				'booking_days_max' => array(
					'name' => 'booking_days_max',
					'description' => __('Enter Maximum days for advance booking (ie: 30 means you can only book <strong>up to</strong> 30 days from now.) Max is 365', 'pm-appointment-book'),
					'field' => 'input',
					'type' => 'number',
					'label' => esc_html(__('Maximum advanced booking', 'pm-appointment-book')),
					'default' => '30',
					'html_after' => '',
					'class' => '',
					'attributes' => 'min="0" max="365"',
					'repeatable' => false,
					'repeatable' => false
				),
				'anonymous_booking' => array(
					'name' => 'anonymous_booking',
					'description' => esc_html(__('Checking this will allow users to book without registering.', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'checkbox',
					'label' => esc_html(__('Check to allow Anonymous booking', 'pm-appointment-book')),
					'default' => 1,
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'review_page' => array(
					'name' => 'review_page',
					'description' => esc_html(__('Enter page post id where you put the checkout page shortcode', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'number',
					'label' => esc_html(__('Checkout page ID', 'pm-appointment-book')),
					'default' => '',
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'thank_you_page' => array(
					'name' => 'thank_you_page',
					'description' => esc_html(__('Enter page post id where you put the thank you page shortcode', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'number',
					'label' => esc_html(__('Thank you page ID', 'pm-appointment-book')),
					'default' => '',
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'user_bookings_page' => array(
					'name' => 'user_bookings_page',
					'description' => esc_html(__('Enter page post id where you put the user booking page shortcode', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'number',
					'label' => esc_html(__('User Bookings page ID', 'pm-appointment-book')),
					'default' => '',
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				
			)
		),
		'holidays' => array(
			'title' => esc_html(__('Holidays', 'pm-appointment-book')),
			'icon' => 'icon-edit',
			'fields' => array(
				'holiday_add_date' => array(
					'name' => 'holiday_add_date',
					'description' => esc_html(__('Select date you want to add as Holiday and Click "Add".', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'text',
					'label' => esc_html(__('Enter Holidays', 'pm-appointment-book')),
					'default' => '',
					'html_after' => '<span id="pmab_add_holiday" class="pmab_btn">'.esc_html(__('Add', 'pm-appointment-book')).'</span>',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'holiday_dates' => array(
					'name' => 'holiday_dates',
					'description' => esc_html(__('Comma separated holidays.', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'text',
					'label' => esc_html(__('Holidays', 'pm-appointment-book')),
					'default' => '',
					'html_after' => '',
					'class' => 'widefat',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				)
			)
		),
		'mail' => array(
			'title' => esc_html(__('Mail', 'pm-appointment-book')),
			'icon' => 'icon-edit',
			'fields' => array(
				'mail_from_name' => array(
					'name' => 'mail_from_name',
					'description' => esc_html(__('Enter "from" name.', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'text',
					'label' => esc_html(__('Mail "from" name', 'pm-appointment-book')),
					'default' => $blogname,
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'mail_from_email' => array(
					'name' => 'mail_from_email',
					'description' => esc_html(__('Enter "from" email.', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'email',
					'label' => esc_html(__('Mail "from" email', 'pm-appointment-book')),
					'default' => $admin_email,
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'mail_to_email' => array(
					'name' => 'mail_to_email',
					'description' => esc_html(__('Enter "to" email where you want to send notifications.', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'email',
					'label' => esc_html(__('Mail to Email', 'pm-appointment-book')),
					'default' => $admin_email,
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'mail_admin_subject' => array(
					'name' => 'mail_admin_subject',
					'description' => esc_html(__('Enter Subject for Bookings (Sent to Admin)', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'text',
					'label' => esc_html(__('Admin Mail Subject', 'pm-appointment-book')),
					'default' => 'New Appointment Booking',
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'mail_user_subject' => array(
					'name' => 'mail_user_subject',
					'description' => esc_html(__('Enter Subject for Bookings (Sent to User)', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'text',
					'label' => esc_html(__('User Mail Subject', 'pm-appointment-book')),
					'default' => 'Your Appointment Booking',
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				)
			)
		),
		'payments' => array(
			'title' => esc_html(__('Payments', 'pm-appointment-book')),
			'icon' => 'icon-edit',
			'fields' => array(
				'enable_free_booking' => array(
					'name' => 'enable_free_booking',
					'description' => esc_html(__('Check to Enable Free Booking', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'checkbox',
					'label' => esc_html(__('Enable Free Booking', 'pm-appointment-book')),
					'default' => 1,
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'free_booking_name' => array(
					'name' => 'free_booking_name',
					'description' => esc_html(__('Name to show for free booking', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'text',
					'label' => esc_html(__('Payment Label', 'pm-appointment-book')),
					'default' => esc_html(__('Free Booking', 'pm-appointment-book')),
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'enable_paypal' => array(
					'name' => 'enable_paypal',
					'description' => esc_html(__('Check to Enable Paypal Payments', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'checkbox',
					'label' => esc_html(__('Enable Paypal Payments', 'pm-appointment-book')),
					'default' => 1,
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'paypal_client_id' => array(
					'name' => 'paypal_client_id',
					'description' => esc_html(__('To generate a ClientID and Secret key.', 'pm-appointment-book')) . sprintf(__('<a target="_blank" href="%s">Click here</a>.', 'pm-appointment-book'),'https://developer.paypal.com/developer/applications/'). '<br /> <strong>'.esc_html(__('NOTE: Sandbox and Live Credentials are DIFFERENT.', 'pm-appointment-book')).'</strong>',
					'field' => 'input',
					'type' => 'text',
					'label' => esc_html(__('Paypal ClientID', 'pm-appointment-book')),
					'default' => '',
					'html_after' => '',
					'class' => 'widefat',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'paypal_secret_key' => array(
					'name' => 'paypal_secret_key',
					'description' => esc_html(__('Enter your paypal Secret key. ', 'pm-appointment-book')),
					'field' => 'input',
					'type' => 'text',
					'label' => esc_html(__('Paypal Secret key', 'pm-appointment-book')),
					'default' => '',
					'html_after' => '',
					'class' => 'widefat',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				),
				'paypal_mode' => array(
					'name' => 'paypal_mode',
					'description' => esc_html(__('Select mode. (Sandbox for testing payments)', 'pm-appointment-book')),
					'field' => 'select',
					'type' => 'select',
					'label' => esc_html(__('Paypal Mode', 'pm-appointment-book')),
					'default' => 'sandbox',
					'options' => array(
						'sandbox' => esc_html(__('Sandbox Payment', 'pm-appointment-book')),
						'live' => esc_html(__('Live Payment', 'pm-appointment-book'))
					),
					'html_after' => '',
					'class' => '',
					'attributes' => '',
					'repeatable' => false,
					'repeatable' => false
				)
			)
		)
	);	
	return $fields;
}

/*
	* Return Holidays as Array
*/

function pm_appointment_book_holidays_array() {
	$options = get_option(PM_APPOINTMENT_BOOK_SETTINGS_OPTION);
	$holidays = (isset($options['holidays']['holiday_dates']) ? $options['holidays']['holiday_dates'] : '' );
	
	$array = explode(',', $holidays);
	$array = array_map('trim',$array);
	
	return $array;
	
}

/*
	* pm_appointment_book_setting_fields
	* Fields for Settings
*/
function pm_appointment_book_set_field($attr,$tab,$opt){
	$output = '';
	$values = pm_appointment_book_setting_fields();
	if($attr == 'name') {
		$output = PM_APPOINTMENT_BOOK_SETTINGS_OPTION . "[{$tab}]" . "[{$opt}]";
	} elseif($attr == 'id') {
		$output = PM_APPOINTMENT_BOOK_SETTINGS_OPTION . "_{$tab}" . "_{$opt}";
	} else {
		$output = $values[$tab]['fields'][$opt][$attr];
	}
	return $output;
}

/*
	* pm_appointment_book_setting_field_name
	* Fields for Settings
*/
function pm_appointment_book_setting_field_name($name){ 
	$field = PM_APPOINTMENT_BOOK_SETTINGS_OPTION."[{$name}]";
	return $field;
}

/*
	*pm_appointment_book_get_schedule_callback
*/

add_action( 'wp_ajax_pm_appointment_book_get_schedule', 'pm_appointment_book_get_schedule_callback' );
add_action( 'wp_ajax_nopriv_pm_appointment_book_get_schedule', 'pm_appointment_book_get_schedule_callback' );
		
function pm_appointment_book_get_schedule_callback() {
	global $wpdb; // this is how you get access to the database
	$output = '';
	$date = sanitize_text_field($_POST['date']);
	$dl = sanitize_text_field($_POST['day']);
	$pid = (int) sanitize_text_field($_POST['pid']);
	$option_days = pm_appointment_book_days();	
	$enabled = get_post_meta($pid, '_pmab_enable_schedule_'.$dl, true);
	if($enabled) {
	$schedules = get_post_meta($pid,'_pmab_day_'.$dl,true);
	$output .= "<p class='error' style='display: none;'>".(__('Please Select Schedule', 'pm-appointment-book'))."</p>";
	$output .= '<ul class="available_time">';
	foreach($schedules['time'] as $key => $time) {
		$booked_times = pm_appointment_book_count_booked($date);
		$kt = str_replace(':','',$time);
		$available = (isset($booked_times[$kt]) ? $schedules['qty'][$key] - $booked_times[$kt] : $schedules['qty'][$key] );
		if($available >= 1) {
			$output .= "<li>
			<label for='pm_ab_time_{$key}'><input type='checkbox' name='pm_ab_time[{$key}]' id='pm_ab_time_{$key}' value='{$time}' /> {$time} <strong>({$available}) ".esc_html(__('available.', 'pm-appointment-book'))."</strong></label>
			</li>";
		} else {
			$output .= "<li>
			<label style='text-decoration: line-through;' for='pm_ab_time_{$key}'>{$time}</label>
			</li>";
		}
		
	}
	$output .= '</ul>';
		
		$data = array(
			'status' => 'success',
			'message' => esc_html(__('Selected day have available schedules.', 'pm-appointment-book')),
			'schedules' => $output,
			'date' => $date,
			'day' => $dl,
			'pid' => $pid
		);
	} else {
		$data = array(
			'status' => 'error',
			'message' => esc_html(__('Error on process. Please refresh page.', 'pm-appointment-book')),
			'schedules' => '',
			'day' => $dl,
			'pid' => $pid
		);
	}
	print json_encode($data);
	die(); // this is required to return a proper result
}

/*
	* Display Payment Methods
*/

function pm_appointment_book_payment_methods() {
	$output = '';
	$options = get_option(PM_APPOINTMENT_BOOK_SETTINGS_OPTION);
	$methods = array();
	$method_count = 0;
	if(!empty($options)){
		$free = (isset($options['payments']['enable_free_booking']) ? $methods['free'] = $options['payments']['free_booking_name'] : '');
		$paypal = (isset($options['payments']['enable_paypal']) ? $methods['paypal'] = esc_html(__('Paypal Payment', 'pm-appointment-book')) : '');
		$method_count = count($methods);
		if($method_count  < 1) {
			$output .= '<p>'.esc_html(__('Please Enable a Payment method to checkout.', 'pm-appointment-book')).'</p>';
		} else {
			$count = 1;
			$output .= "
				<div class='form_field_wrapper'>
				<label>".esc_html(__('Select Payment Method', 'pm-appointment-book'))."</label>";
			foreach($methods as $key => $method) {
				$checked = ($count == 1 ? 'checked' : '');
				$output .= "<div><label for='booking_form_{$key}'><input {$checked} type='radio' value='{$key}' name='booking_form_payment_method' id='booking_form_{$key}' /> {$method}</label></div>";
				$count ++;
			}
			$output .= "</div>";
		}
	}
	
	return array(
		'count' => $method_count,
		'output' => $output
	);
}

/*
	* Display Booking Details
*/

function pm_appointment_book_booking_details($session) {
	$options = get_option(PM_APPOINTMENT_BOOK_SETTINGS_OPTION);
	//Option Values 
	$symbol = ($options ? $options['general']['currency_symbol'] : '$');
	$currency = ($options ? $options['general']['currency'] : 'USD');

	$price = esc_html($session['booking_form_price']);
	$qty = (int) esc_html($session['booking_form_price_qty']);
	$total_price = $qty * $price;
	$date = esc_html($session['booking_form_date']);
	$time_array = $session['pm_ab_time'];
	$time = '';
	foreach($time_array as $t) {
		$time .= $t.'<br />';
	}
	
	$name = trim(esc_html($session['booking_form_name']));
	$email = trim(esc_html($session['booking_form_email']));
	$contact = trim(esc_html($session['booking_form_number']));
	$note = nl2br(trim(esc_html($session['booking_form_note'])));
	$payment_method_selected_val = trim(esc_html($session['booking_form_payment_method']));
	$payment_method_selected = '';
	if($payment_method_selected_val == 'free') {
	$payment_method_selected = $options['payments']['free_booking_name'];
	} elseif($payment_method_selected_val == 'paypal') { 
	$payment_method_selected = esc_html(__('Paypal Payment', 'pm-appointment-book'));
	}

	$output = '';
	$output .= "<table class='form-table' border='1' width='100%'>";
	$output .= "<tbody>";
	$output .= "
		<tr>
			<td>".esc_html(__('Name', 'pm-appointment-book'))."</td>
			<td>{$name}</td>
		</tr>
		<tr>
			<td>".esc_html(__('Email', 'pm-appointment-book'))."</td>
			<td>{$email}</td>
		</tr>
		<tr>
			<td>".esc_html(__('Number', 'pm-appointment-book'))."</td>
			<td>{$contact}</td>
		</tr>
		<tr>
			<td>".esc_html(__('Date', 'pm-appointment-book'))."</td>
			<td>{$date}</td>
		</tr>
		<tr>
			<td>".esc_html(__('Time', 'pm-appointment-book'))."</td>
			<td>{$time}</td>
		</tr>
		<tr>
			<td>".esc_html(__('# of Appointments', 'pm-appointment-book'))."</td>
			<td>{$qty}</td>
		</tr>
		<tr>
			<td>".esc_html(__('Price per appointment', 'pm-appointment-book'))."</td>
			<td>{$symbol}{$price}</td>
		</tr>
		<tr>
			<td>".esc_html(__('Total price', 'pm-appointment-book'))."</td>
			<td>{$symbol}{$total_price}</td>
		</tr>
		<tr>
			<td>".esc_html(__('Payment Method', 'pm-appointment-book'))."</td>
			<td>{$payment_method_selected}</td>
		</tr>
		<tr>
			<td>".esc_html(__('Additional notes', 'pm-appointment-book'))."</td>
			<td>{$note}</td>
		</tr>
		";
	$output .= "</tbody>";
	$output .= "</table>";
	
	return $output;
}

/*
	* pm_appointment_book_add_booking
*/

function pm_appointment_book_add_booking($args) {
	global $wpdb;
	$table_name = $wpdb->prefix . 'pm_appointment_book';
	
	$defaults = array(
		'postid'	=>	'',
		'booking_date'	=> '',
		'time'	=>  ''
	);

	$args = wp_parse_args( $args, $defaults );

	$add = $wpdb->query(
		$wpdb->prepare(
			"INSERT INTO {$table_name} SET
				`postid`    = '%s',
				`booking_date`    = '%s',
				`time`    = '%s',
				`date`    = NOW()
			;",
			absint( $args['postid'] ),
			$args['booking_date'],
			$args['time']
		)
	);
	
	return $add;
}

/*
	* pm_appointment_book_count_booked
*/

function pm_appointment_book_count_booked($date) {
	global $wpdb;
	$table_name = $wpdb->prefix . 'pm_appointment_book';
	$booking_date = date('Y-m-d' ,strtotime(esc_html($date)));
	$array = array();
	$results = $wpdb->get_results( $wpdb->prepare( 
		"
			SELECT `booking_date`, `time`, count(`time`) as `count` 
			FROM `{$table_name}` 
			WHERE `booking_date` = '%s' 
			GROUP BY `time` 
		", 
		$booking_date
	), ARRAY_A );
	foreach($results as $result) {
		$key = str_replace(':','',$result['time']);
		$array[$key] = $result['count'];
	}
	return $array;
}


/*
	* Check Paypal Requirements
*/

function pm_appointment_book_paypal_settings() {
	$options = get_option(PM_APPOINTMENT_BOOK_SETTINGS_OPTION);
	$paypal_setting = $options['payments'];
	$rvpageid = ($options ? $options['general']['review_page'] : '');
	$rvpageurl = (!empty($rvpageid) ? get_permalink($rvpageid) : '');
	$typageid = ($options ? $options['general']['thank_you_page'] : '');
	$typageurl = (!empty($typageid) ? get_permalink($typageid) : '#');
	$client_id = (isset($paypal_setting['paypal_client_id']) ? $paypal_setting['paypal_client_id'] : '');
	$secret_key = (isset($paypal_setting['paypal_secret_key']) ? $paypal_setting['paypal_secret_key'] : '');
	$debug = (isset($paypal_setting['enable_paypal_debug']) ? 'enabled' : 'disabled');
	$paypal_options = array(
		'client_id' => $client_id,
		'secret_key' => $secret_key,
		'mode' => $paypal_setting['paypal_mode'],
		'currency' => $options['general']['currency'],
		'redirect_url' => $rvpageurl,
		'debug' => $debug,
		'success' => $typageurl
	);
	
	return $paypal_options;
}

/*
	* Get Paypal Payment Data
*/

function pm_appointment_book_create_data($session, $type = 'create') {
	$error = false;
	$paypal_options = pm_appointment_book_paypal_settings();
	
	foreach($paypal_options as $paypal_option) {
		if(empty($paypal_option)) {
			$error = true;
		}
	}
	if($error):
		print "<p>".esc_html(__('Paypal Settings Error.', 'pm-appointment-book'))."</p>";
	else:
		//Start Paypal Processing
		$paypal_autoload = __DIR__."/libs/paypal/vendor/autoload.php";
		$debug = __DIR__."/libs/paypal/debug.php";
		$config = __DIR__."/libs/paypal/config.php";
		$profile = __DIR__."/libs/paypal/profile.php";
		$script = ($type == 'create' ? __DIR__."/libs/paypal/create.php" : __DIR__."/libs/paypal/execute.php" );
		if(!file_exists($paypal_autoload)) {
			echo "Paypal payment is not supported on your System. Please Upgrade to PHP 5.3 or higher.";
			exit(1);
		}
		require_once $paypal_autoload;
		if($paypal_options['debug'] == 'enabled') {
			require_once $debug;
		}
		if(!file_exists($config)) {
			echo "Can't load config file..";
			exit(1);
		}
		require_once $config;
		//require_once $profile;
		require_once $script;
		return $return_status;
		/*
		$tls = __DIR__."/libs/paypal/TlsCheck.php";
		require_once $tls;
		*/
	endif;
}

function pm_appointment_book_send_mail($data, $session) {
	$options = get_option(PM_APPOINTMENT_BOOK_SETTINGS_OPTION);
	$email_body = '';
	$mail_settings = array(
		'mail_from_name' => (isset($options['mail']['mail_from_name']) ? esc_html($options['mail']['mail_from_name']) : ''  ),
		'mail_from_email' => (isset($options['mail']['mail_from_email']) ? esc_html($options['mail']['mail_from_email']) : ''  ),
		//'mail_to_name' => (isset($options['mail']['mail_to_name']) ? esc_html($options['mail']['mail_to_name']) : ''  ),
		'mail_to_email' => (isset($options['mail']['mail_to_email']) ? esc_html($options['mail']['mail_to_email']) : ''  ),
		'mail_admin_subject' => (isset($options['mail']['mail_admin_subject']) ? esc_html($options['mail']['mail_admin_subject']) : ''  ),
		'mail_user_subject'	 => (isset($options['mail']['mail_user_subject']) ? esc_html($options['mail']['mail_user_subject']) : ''  ),
	);
	
	add_filter( 'wp_mail_content_type', 'pm_appointment_book_set_html_content_type' );
	
	if( $data['type'] == 'admin') {
		$email_body .= "<p>".esc_html(__("You have a new booking. See below for details.", "pm-appointment-book"))."</p>";
	} else {
		$email_body .= "<p>".esc_html(__("Thanks for booking. Here are your booking details.", "pm-appointment-book"))."</p>";
	}
	
	$email_body .= "<h3>Booking Details:</h3>";
	$email_body .= pm_appointment_book_booking_details($session);
	
	//$current_user = wp_get_current_user();
	$headers[] = "From: {$mail_settings['mail_from_name']} <{$mail_settings['mail_from_email']}>";

	$body =  $email_body;
	if( $data['type'] == 'admin') {
		wp_mail( $mail_settings['mail_to_email'], $mail_settings['mail_admin_subject'] . ' - ' . $data['pid'], $body, $headers);
	} else {
		wp_mail( $data['user_email'], $mail_settings['mail_user_subject'] . ' - ' . $data['pid'], $body, $headers);
	}
	// Reset content-type to avoid conflicts -- http://core.trac.wordpress.org/ticket/23578
	remove_filter( 'wp_mail_content_type', 'pm_appointment_book_set_html_content_type' );
	
}

function pm_appointment_book_set_html_content_type() {
	return 'text/html';
}

/*
	* Add Appointment Custom Columns
*/

add_filter('manage_pm-appointment_posts_columns', 'pm_appointment_book_columns_head');
add_action('manage_pm-appointment_posts_custom_column', 'pm_appointment_book_columns_content', 10, 2);

function pm_appointment_book_columns_head($defaults) {
	$defaults['pm_appointment_book_status'] = esc_html(__('Status', 'pm-process-mover'));
	$defaults['pm_appointment_book_date'] = esc_html(__('Appointment Date', 'pm-process-mover'));
	$defaults['pm_appointment_book_total_appointments'] = esc_html(__('No. of Appointments', 'pm-process-mover'));
	$defaults['pm_appointment_book_time'] = esc_html(__('Appointment Time', 'pm-process-mover'));
	$defaults['pm_appointment_book_email'] = esc_html(__('Email', 'pm-process-mover'));
	$defaults['pm_appointment_book_contact_number'] = esc_html(__('Contact Number', 'pm-process-mover'));
	return $defaults;
}

function pm_appointment_book_columns_content($column_name, $pid) {
	$details = get_post_meta($pid,'_appointment_details', true);
	$output = '';
	if ($column_name == 'pm_appointment_book_status') {
		$status = get_post_status($pid);
		$color = '';
		switch ($status) {
			case 'completed':
				$color = "blue;";
				break;
			case 'cancelled':
				$color = "red;";
				break;
			case 'pending':
				$color = "#ffa500;";
				break;
			case 'payment-pending':
				$color = "#ffa500;";
				break;
			default:
				$color = "#000;";
		}
		
		
		$date = "<strong style='color: {$color}'>".esc_html($status)."</strong>";
		$output .= $date;
    }
	if ($column_name == 'pm_appointment_book_date') {
		$date = esc_html($details['booking_form_date']);
		$output .= $date;
    }
	if ($column_name == 'pm_appointment_book_total_appointments') {
		$total = esc_html($details['booking_form_price_qty']);
		$output .= $total;
    }
	if ($column_name == 'pm_appointment_book_time') {
		$time_array = $details['pm_ab_time'];
		$time = '';
		foreach($time_array as $t) {
			$time .= $t.'<br />';
		}
		$output .= $time;
    }
	if ($column_name == 'pm_appointment_book_email') {
		$email = esc_html($details['booking_form_email']);
		$output .= $email;
    }
	if ($column_name == 'pm_appointment_book_contact_number') {
		$contact_number = esc_html( $details['booking_form_number'] );
		$output .= $contact_number;
    }
	print $output;
}

/*
	* Returns the Next and Previous Links
*/

function pm_appointment_book_calendar_control($month, $year) {
	$links = array();
	$prevMonth = $month - 1;
	$nextMonth = $month + 1;
	$prevYear = $year;
	$nextYear = $year;

	if ($prevMonth < 1) {
		$prevMonth = 1;
		$prevYear -= 1;
	}

	if ($nextMonth > 12) {
		$nextMonth = 1;
		$nextYear += 1;
	}
	
	$links['next'] = "?month={$nextMonth}&year={$nextYear}";
	$links['prev'] = "?month={$prevMonth}&year={$prevYear}";
	return $links;
}

?>
