<?php

/*
	* pm_appointment_book_calendar_callback
	* Postmeta for Calendars
	* pm-appointment-book
*/
function pm_appointment_book_calendar_callback( $post ) {
	wp_nonce_field( plugin_basename( __FILE__ ), 'pm_appointment_book_calendar_noncename' );
	wp_enqueue_script( 'jquery-ui-datepicker' );
	wp_enqueue_script( 'jquery-ui-slider' );
	wp_enqueue_script( 'jquery-ui-tabs' );
	wp_register_style( 'jquery-ui-styles','https://ajax.googleapis.com/ajax/libs/jqueryui/1.11.2/themes/smoothness/jquery-ui.css', '', PM_APPOINTMENT_BOOK_VERSION, 'all'  );
	wp_enqueue_style( 'jquery-ui-styles' );	
	
	wp_enqueue_style( 'pm-ab-admin-timepicker-style', PM_APPOINTMENT_BOOK_DIR.'modules/libs/timepicker/jquery-ui-timepicker-addon.css', '', PM_APPOINTMENT_BOOK_VERSION, 'all' );
	wp_enqueue_script( 'pm-ab-admin-timepicker-script', PM_APPOINTMENT_BOOK_DIR.'modules/libs/timepicker/jquery-ui-timepicker-addon.js', array('jquery'), PM_APPOINTMENT_BOOK_VERSION, true );
	
	wp_enqueue_style( 'pm-ab-admin-appointment-book-style', PM_APPOINTMENT_BOOK_DIR.'modules/css/pm-appointment-book.css', '', PM_APPOINTMENT_BOOK_VERSION, 'all' );
	wp_enqueue_script( 'pm-ab-admin-appointment-book-script', PM_APPOINTMENT_BOOK_DIR.'modules/js/pm-appointment-book.js', array('jquery'), PM_APPOINTMENT_BOOK_VERSION, true );
	$days = pm_appointment_book_days();
	$duration = (get_post_meta($post->ID,'_pmab_schedule_duration', true) ? get_post_meta($post->ID,'_pmab_schedule_duration', true) : 30);
	$price = (get_post_meta($post->ID,'_pmab_schedule_price', true) ? get_post_meta($post->ID,'_pmab_schedule_price', true) : 1);
	
	?>
	<div id="appointment_book_calendar_post_meta">
		<h3><?php esc_html(_e('Set working hours', 'pm-appointment-book')); ?></h3>
		<div class="pmab_field_wrapper">
			<label for="pmab_schedule_duration"><?php esc_html(_e('Duration: ','pm-appointment-book')); ?></label>
			<input type="number" name="_pmab_schedule_duration" id="pmab_schedule_duration" class="pmab_field" min="10" size="4" value="<?php print $duration; ?>"  />
			<p class="description"><?php esc_html(_e('Enter the duration in minutes for each session or schedule.','pm-appointment-book')); ?></p>
		</div>
		<div class="pmab_field_wrapper">
			<label for="pmab_schedule_price"><?php esc_html(_e('Price per appointment: ','pm-appointment-book')); ?></label>
			<input type="number" name="_pmab_schedule_price" id="pmab_schedule_price" class="pmab_field" step="0.01"  value="<?php print $price; ?>"  />
			<p class="description"><?php esc_html(_e('Enter price per single appointment.','pm-appointment-book')); ?></p>
		</div>
		<div id="pm_ab_days">
			<ul>
				<?php foreach($days as $key => $day): ?>
					<li><a href="#tab_<?php print $key; ?>" title="<?php print $day?>"><?php print $day?></a></li>
				<?php endforeach; ?>
			</ul>
			<?php foreach($days as $key => $day): 
				$enabled = get_post_meta($post->ID, '_pmab_enable_schedule_'.$key, true);
				$schedules = (get_post_meta($post->ID, '_pmab_day_'.$key, true) ? get_post_meta($post->ID, '_pmab_day_'.$key, true) : null);
			?>
				<div class="tab_day_wrapper" id="tab_<?php print $key; ?>">
					<div class="pmab_field_wrapper">
						<label for="enable_schedule_<?php print $key; ?>"><input <?php print (!empty($enabled) ? 'checked' : '' ); ?> type="checkbox" class="pmab_enable_schedule" name="_pmab_enable_schedule_<?php print $key; ?>" id="enable_schedule_<?php print $key; ?>" /><?php esc_html(_e('Enable Schedule','pm-appointment-book')); ?></label>
						<p class="description"><?php esc_html(printf(__('Check to enable schedule every %s','pm-appointment-book'), $day)); ?></p>
					</div>
					<div class="tab_day_table" style="display: <?php print (!empty($enabled) ? 'table' : 'none' ); ?>;">
					<table id="tab_<?php print $key; ?>_table" border="1" >
						<thead>
						<tr>
							<td><?php esc_html(_e('Time','pm-appointment-book')); ?></td>
							<td><?php esc_html(_e('Capacity','pm-appointment-book')); ?></td>
							<td><?php esc_html(_e('Delete?','pm-appointment-book')); ?></td>
						</tr>
						</thead>
						<tbody>
						<?php if( !empty($schedules) ):
							foreach($schedules['time'] as $pos => $time): 
							if(!empty($time) ):
							?>
							<tr>
								<td><input type="text" class="pmab_field pmab_time" name="_pmab_day_<?php print $key; ?>[time][]" value="<?php print $time; ?>" /></td>
								<td><input type="number" min="1" class="pmab_field pmab_qty" name="_pmab_day_<?php print $key; ?>[qty][]" value="<?php print $schedules['qty'][$pos]; ?>" /></td>
								<td><input type="button" id="pmAbdeleteRowbtn" value="<?php esc_html(_e('Delete','pm-appointment-book')); ?>" onclick="pmAbdeleteRow(this,'tab_<?php print $key; ?>_table')"/></td>
							</tr>
							<?php endif; ?>
						<?php endforeach; 
						else:
						?>
						<tr>
							<td><input type="text" class="pmab_field pmab_time" name="_pmab_day_<?php print $key; ?>[time][]" value="00:00" /></td>
							<td><input type="number" min="1" class="pmab_field pmab_qty" name="_pmab_day_<?php print $key; ?>[qty][]" value="1" /></td>
							<td><input type="button" id="pmAbdeleteRowbtn" value="<?php esc_html(_e('Delete','pm-appointment-book')); ?>" onclick="pmAbdeleteRow(this,'tab_<?php print $key; ?>_table')"/></td>
						</tr>
						<?php endif; ?>
						</tbody>
					</table>
					<input type="button" id="pmAbinsRowbtn" value="<?php esc_html(_e('Add time','pm-appointment-book')); ?>" onclick="pmAbinsRow('tab_<?php print $key; ?>_table')"/>
					</div>
				</div>
			<?php endforeach; ?>
		</div>
	</div>
	<?php
}

add_action( 'save_post', 'pm_appointment_book_calendar_callback_save_postdata' );
function pm_appointment_book_calendar_callback_save_postdata( $post_id ) {

	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	  return;
	if ( !empty( $_POST['pm_appointment_book_calendar_noncename'] ) && !wp_verify_nonce( $_POST['pm_appointment_book_calendar_noncename'], plugin_basename( __FILE__ ) ) )
	  return;
	if ( !empty($_POST['post_type']) && 'calendar' == $_POST['post_type'] ) 
	{
	if ( !current_user_can( 'edit_page', $post_id ) )
		return;
	}
	else
	{
	if ( !current_user_can( 'edit_post', $post_id ) )
		return;
	}
	$days = pm_appointment_book_days();
	//Validate
	foreach($days as $key => $day):
		$day_enabled = (isset($_POST['_pmab_enable_schedule_'.$key]) ? $_POST['_pmab_enable_schedule_'.$key] : '');
		update_post_meta( $post_id, '_pmab_enable_schedule_'.$key, $day_enabled);
		
		if(isset($_POST['_pmab_day_'.$key]) && !empty($_POST['_pmab_day_'.$key]) ) {
			update_post_meta( $post_id, '_pmab_day_'.$key, $_POST['_pmab_day_'.$key]);
		}
	endforeach;
	if(isset($_POST['_pmab_schedule_duration']) && !empty($_POST['_pmab_schedule_duration']) ) {
		update_post_meta( $post_id, '_pmab_schedule_duration', $_POST['_pmab_schedule_duration']);
	}
	
	if(isset($_POST['_pmab_schedule_price']) && !empty($_POST['_pmab_schedule_price']) ) {
		$price = number_format($_POST['_pmab_schedule_price'], 2, '.', '');
		update_post_meta( $post_id, '_pmab_schedule_price', $price);
	} elseif ( empty($_POST['_pmab_schedule_price']) ) {
		update_post_meta( $post_id, '_pmab_schedule_price', '0.00');
	}
		
		
	
}

?>