<?php
// No, Thanks. Direct file access forbidden.
! defined( 'ABSPATH' ) AND exit;

// INIT
add_action( 'after_setup_theme', array( 'completed_post_status', 'init' ) );
add_action( 'after_setup_theme', array( 'pending_post_status', 'init' ) );
add_action( 'after_setup_theme', array( 'cancelled_post_status', 'init' ) );
add_action( 'after_setup_theme', array( 'processing_post_status', 'init' ) );


class completed_post_status extends pm_appointment_book_custom_post_status
{
	/**
	 * @access protected
	 * @var string
	 */
	static protected $instance;


	/**
	 * Creates a new instance. Called on 'after_setup_theme'.
	 * May be used to access class methods from outside.
	 *
	 * @return void
	 */
	static public function init()
	{
		null === self :: $instance and self :: $instance = new self;
		return self :: $instance;
	}


	public function __construct()
	{
		// Set your data here. Only "$post_status" is required.
		$this->post_status = 'completed';

		// The post types where you want to add the custom status. Allowed are string and array
		$this->post_type = 'pm-appointment';

		// @see parent class: defaults inside add_post_status()
		$this->args = array();

		parent :: __construct();
	}
}

class cancelled_post_status extends pm_appointment_book_custom_post_status
{
	/**
	 * @access protected
	 * @var string
	 */
	static protected $instance;


	/**
	 * Creates a new instance. Called on 'after_setup_theme'.
	 * May be used to access class methods from outside.
	 *
	 * @return void
	 */
	static public function init()
	{
		null === self :: $instance and self :: $instance = new self;
		return self :: $instance;
	}


	public function __construct()
	{
		// Set your data here. Only "$post_status" is required.
		$this->post_status = 'cancelled';

		// The post types where you want to add the custom status. Allowed are string and array
		$this->post_type = 'pm-appointment';

		// @see parent class: defaults inside add_post_status()
		$this->args = array();

		parent :: __construct();
	}
}

class pending_post_status extends pm_appointment_book_custom_post_status
{
	/**
	 * @access protected
	 * @var string
	 */
	static protected $instance;


	/**
	 * Creates a new instance. Called on 'after_setup_theme'.
	 * May be used to access class methods from outside.
	 *
	 * @return void
	 */
	static public function init()
	{
		null === self :: $instance and self :: $instance = new self;
		return self :: $instance;
	}


	public function __construct()
	{
		// Set your data here. Only "$post_status" is required.
		$this->post_status = 'payment-pending';

		// The post types where you want to add the custom status. Allowed are string and array
		$this->post_type = 'pm-appointment';

		// @see parent class: defaults inside add_post_status()
		$this->args = array();

		parent :: __construct();
	}
}

class processing_post_status extends pm_appointment_book_custom_post_status
{
	/**
	 * @access protected
	 * @var string
	 */
	static protected $instance;


	/**
	 * Creates a new instance. Called on 'after_setup_theme'.
	 * May be used to access class methods from outside.
	 *
	 * @return void
	 */
	static public function init()
	{
		null === self :: $instance and self :: $instance = new self;
		return self :: $instance;
	}


	public function __construct()
	{
		// Set your data here. Only "$post_status" is required.
		$this->post_status = 'processing';

		// The post types where you want to add the custom status. Allowed are string and array
		$this->post_type = 'pm-appointment';

		// @see parent class: defaults inside add_post_status()
		$this->args = array();

		parent :: __construct();
	}
}