<?php 
/*
	* pm_appointment_book_adminscripts
	* Enq Scripts and StyleSheets
	* FontAwesome: //maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css

*/

function pm_appointment_book_register_settings() {
	add_menu_page(esc_html(sprintf(__( '%s Settings', 'pm-appointment-book' ), PM_APPOINTMENT_BOOK_PLUGIN_NAME)), esc_html(sprintf(__( '%s Settings', 'pm-appointment-book' ), PM_APPOINTMENT_BOOK_PLUGIN_NAME)), 'manage_options', 'pm_appointment_book_settings', 'pm_appointment_book_settings_page', '' );
	add_action( 'admin_init', 'pm_appointment_book_settings_register_callback' );
}
add_action( 'admin_menu', 'pm_appointment_book_register_settings' );


/*
	* pm_appointment_book_settings_register_callback
*/

function pm_appointment_book_settings_register_callback() {
	//register our settings
	register_setting( 'pm-appointment-book-settings-group', PM_APPOINTMENT_BOOK_SETTINGS_OPTION, 'pm_appointment_book_settings_validate');
}

/*
	* pm_appointment_book_settings_validate
*/

function pm_appointment_book_settings_validate($input) {
	foreach($input as $key => $value) {
		if(is_array($input[$key])) {
			$input[$key] = array_filter($input[$key]);
		}
	}
	return $input;
}


/*
	* Settings Page for Social Quiz
*/


function pm_appointment_book_settings_page() {
	wp_enqueue_script( 'jquery-ui-datepicker' );
	wp_enqueue_script( 'jquery-ui-slider' );
	wp_enqueue_script( 'jquery-ui-tabs' );
	wp_register_style( 'jquery-ui-styles','https://ajax.googleapis.com/ajax/libs/jqueryui/1.11.2/themes/smoothness/jquery-ui.css', '', PM_APPOINTMENT_BOOK_VERSION, 'all'  );
	wp_enqueue_style( 'jquery-ui-styles' );	
	
	wp_enqueue_style( 'pm-ab-admin-timepicker-style', PM_APPOINTMENT_BOOK_DIR.'modules/libs/timepicker/jquery-ui-timepicker-addon.css', '', PM_APPOINTMENT_BOOK_VERSION, 'all' );
	wp_enqueue_script( 'pm-ab-admin-timepicker-script', PM_APPOINTMENT_BOOK_DIR.'modules/libs/timepicker/jquery-ui-timepicker-addon.js', array('jquery'), PM_APPOINTMENT_BOOK_VERSION, true );
	
	wp_enqueue_style( 'pm-ab-admin-appointment-book-style', PM_APPOINTMENT_BOOK_DIR.'modules/css/pm-appointment-book.css', '', PM_APPOINTMENT_BOOK_VERSION, 'all' );
	wp_enqueue_script( 'pm-ab-admin-appointment-book-script', PM_APPOINTMENT_BOOK_DIR.'modules/js/pm-appointment-book.js', array('jquery'), PM_APPOINTMENT_BOOK_VERSION, true );

	$setting_fields = pm_appointment_book_setting_fields();
	//delete_option(PM_APPOINTMENT_BOOK_SETTINGS_OPTION);
	$options = get_option(PM_APPOINTMENT_BOOK_SETTINGS_OPTION);
	?>
	<div class="wrap">
		<div id="icon-edit" class="icon32"></div>
		<h2><?php esc_html(printf(__( '%s Settings', 'pm-appointment-book' ), PM_APPOINTMENT_BOOK_PLUGIN_NAME)); ?></h2>
		<form method="post" class="pm_appointment_book_form" action="options.php"> 
			<?php settings_fields( 'pm-appointment-book-settings-group' ); ?>
			<?php do_settings_sections( 'pm-appointment-book-settings-group' ); ?>
			<div id="pm_ab_setting_tabs">
				<ul>
				<?php foreach($setting_fields as $tab_key =>  $tab): ?>
					<li><a href="#tab_<?php print $tab_key; ?>" title="<?php print $tab['title']; ?>"><?php print $tab['title']; ?></a></li>
				<?php endforeach; ?>
				</ul>
				<?php foreach($setting_fields as $tab_key =>  $tab_fields): ?>
				<div class="tab_settings_wrapper" id="tab_<?php print $tab_key; ?>">
					<table class="form-table">
					<?php foreach($tab_fields['fields'] as $fkey => $field): 
					$default_value = $setting_fields[$tab_key]['fields'][$field['name']]['default'];
					$option = (isset($options[$tab_key][$fkey]) ? $options[$tab_key][$fkey] : $default_value);
					if( $field['type'] == 'checkbox'): 
					$checked = (isset($options[$tab_key][$fkey]) ? 'checked' : '');
					?>
					<tr>
						<td><p><?php print $field['label']; ?></p></td>
						<td>
							<label for="<?php print pm_appointment_book_set_field('id',$tab_key,$field['name']); ?>">
								<input <?php print $checked; ?> <?php print pm_appointment_book_set_field('attributes',$tab_key,$field['name']); ?> type="<?php print pm_appointment_book_set_field('type',$tab_key,$field['name']); ?>" name="<?php print pm_appointment_book_set_field('name',$tab_key,$field['name']); ?>" id="<?php print pm_appointment_book_set_field('id',$tab_key,$field['name']); ?>" value="<?php print $option; ?>" class="settings_field <?php print pm_appointment_book_set_field('class',$tab_key,$field['name']); ?>" /><?php print pm_appointment_book_set_field('html_after',$tab_key,$field['name']); ?> <?php print pm_appointment_book_set_field('description',$tab_key,$field['name']); ?>
							</label>
						</td>
					</tr>
					<?php elseif( $field['type'] == 'select'): ?>
					<tr>
						<td><label for="<?php print pm_appointment_book_set_field('id',$tab_key,$field['name']); ?>"><?php print $field['label']; ?></label></td>
						<td>
							<select <?php print pm_appointment_book_set_field('attributes',$tab_key,$field['name']); ?> name="<?php print pm_appointment_book_set_field('name',$tab_key,$field['name']); ?>" id="<?php print pm_appointment_book_set_field('id',$tab_key,$field['name']); ?>" class="settings_field <?php print pm_appointment_book_set_field('class',$tab_key,$field['name']); ?>" >
							<?php foreach($field['options'] as $select_key => $select_value):
							$selected = ($option == $select_key ? 'selected' : '');
							?>
								<option <?php print $selected; ?> value="<?php print $select_key; ?>"><?php print $select_value; ?></option>
							<?php endforeach; ?>
							</select>
							<?php print pm_appointment_book_set_field('html_after',$tab_key,$field['name']); ?>
							<p class="description"><?php print pm_appointment_book_set_field('description',$tab_key,$field['name']); ?></p>
						</td>
					</tr>
					<?php else: ?>
					<tr>
						<td><label for="<?php print pm_appointment_book_set_field('id',$tab_key,$field['name']); ?>"><?php print $field['label']; ?></label></td>
						<td>
							<input <?php print pm_appointment_book_set_field('attributes',$tab_key,$field['name']); ?> type="<?php print pm_appointment_book_set_field('type',$tab_key,$field['name']); ?>" name="<?php print pm_appointment_book_set_field('name',$tab_key,$field['name']); ?>" id="<?php print pm_appointment_book_set_field('id',$tab_key,$field['name']); ?>" value="<?php print $option; ?>" class="settings_field <?php print pm_appointment_book_set_field('class',$tab_key,$field['name']); ?>" /><?php print pm_appointment_book_set_field('html_after',$tab_key,$field['name']); ?>
							<p class="description"><?php print pm_appointment_book_set_field('description',$tab_key,$field['name']); ?></p>
						</td>
					</tr>
					<?php 
						endif;
					endforeach; ?>
					</table>
				</div>
				<?php endforeach; ?>
			</div>
			<?php submit_button(); ?>
		</form>
	</div>
	<?php
}