<?php
add_shortcode( 'pm-appointment-book-thank-you-page', 'pm_appointment_book_thank_you' );
add_shortcode( 'pm-appointment-book-review-page', 'pm_appointment_book_review' );
add_shortcode( 'pm-appointment-book-user-bookings', 'pm_appointment_book_user_bookings' );


/*
	* ShortCode
	* pm_appointment_book
	* pm_appointment_book_user_bookings
*/

function pm_appointment_book_user_bookings() {
	wp_enqueue_style( 'pm-ab-fe-appointment-book-style', PM_APPOINTMENT_BOOK_DIR.'modules/frontend/css/pm-appointment-book-fe.css', '', PM_APPOINTMENT_BOOK_VERSION, 'all' );
	
	global $wpdb;
	global $post;
	$options = get_option(PM_APPOINTMENT_BOOK_SETTINGS_OPTION);		
	$output = '';
	$userid = get_current_user_id();
	$userid = ($userid == 0 ? 0 : $userid);
	$user_bookings_id = ($options ? $options['general']['user_bookings_page'] : '');
	$user_bookings_page = (!empty($user_bookings_id) ? get_permalink($user_bookings_id) : '#');
	
	$query = new WP_Query( array(  ) );
	if( !is_user_logged_in() ):
		$output .= "<p>".esc_html(__('You must be logged-in to access this page.', 'pm-appointment-book'))."</p>";
	elseif(!isset($user_bookings_id) || empty($user_bookings_id)):
		$output .= "<p>".esc_html(__('You have not set the User Bookings ID on Settings page..', 'pm-appointment-book'))."</p>";
	else:
		if( isset($_GET['action'], $_GET['pid']) ) {
			$cid = (int) esc_html($_GET['pid']);
			if($_GET['action'] == 'cancel' && is_int($cid) ) {
				$post_tmp = get_post($cid);
				$author_id = $post_tmp->post_author;
				if($author_id == $userid) {
					$my_post = array(
						  'ID' => $cid,
						  'post_status' => 'cancelled'
					);
					// Update the post into the database
					$update = wp_update_post( $my_post );
					if($update) {
						$output .= "<p>".esc_html(__('Appointment cancel successful.', 'pm-appointment-book'))."</p>";
					}
				} else {
					$output .= "<p>".esc_html(__('Sorry! You can\'t cancel this Appointment.', 'pm-appointment-book'))."</p>";
				}
				
			}
		}
		$args = array(
			'post_type' => 'pm-appointment',
			'author' => $userid,
			'posts_per_page' => -1,
			'orderby' => 'date',
			'order' => 'DESC',
			'post_status' => 'any'
		);
		$the_query = new WP_Query( $args );

		// The Loop
		if ( $the_query->have_posts() ) {
			$output .= "<section id='pmab_booking_wrapper'>";
			$output .= "<table class='form-table' border='1'>
			<thead>
				<tr>
				<th>".esc_html(__('ID', 'pm-appointment-book'))."</th>
				<th>".esc_html(__('Date', 'pm-appointment-book'))."</th>
				<th>".esc_html(__('Time', 'pm-appointment-book'))."</th>
				<th>".esc_html(__('Total Price', 'pm-appointment-book'))."</th>
				<th>".esc_html(__('Status', 'pm-appointment-book'))."</th>
				<th>".esc_html(__('Action', 'pm-appointment-book'))."</th>
				</tr>
			</thread>
			<tbody>
			";
			while ( $the_query->have_posts() ) {
				$the_query->the_post();
				$pid = $the_query->post->ID;
				$session = get_post_meta($pid,'_appointment_details', true);
				$status = get_post_status($pid);
				
				$symbol = ($options ? $options['general']['currency_symbol'] : '$');

				$price = esc_html($session['booking_form_price']);
				$qty = (int) esc_html($session['booking_form_price_qty']);
				$total_price = $qty * $price;
				
				$time_array = $session['pm_ab_time'];
				$time = '';
				foreach($time_array as $t) {
					$time .= $t.'<br />';
				}
				$cancel_url = (!empty($user_bookings_id) ? get_permalink($user_bookings_id).'?action=cancel&pid='.$pid : '#');
				$action = ($status != 'cancelled' ? sprintf(__('%s', 'pm-appointment-book'), '<a onclick="return confirm(\'Confirm Cancel? This action cannot be undone!\'); " href='.$cancel_url.'>Cancel</a>' ) : "--");
				$output .="
					<tr>
						<td>".esc_html(sprintf(__('%s', 'pm-appointment-book'), get_the_title() ))."</td>
						<td>".esc_html(sprintf(__('%s', 'pm-appointment-book'), $session['booking_form_date'] ))."</td>
						<td>".sprintf(__('%s', 'pm-appointment-book'), $time )."</td>
						<td>".esc_html(sprintf(__('%s', 'pm-appointment-book'), $symbol.$total_price ))."</td>
						<td>".esc_html(sprintf(__('%s', 'pm-appointment-book'), $status ))."</td>
						<td>".sprintf(__('%s', 'pm-appointment-book'), $action )."</td>
					</tr>
				";
			}
			$output .= "</tbody></table></section>";
		} else {
			$output .= "<p>".esc_html(__('No Appointments available', 'pm-appointment-book'))."</p>";
		}
		/* Restore original Post Data */
		wp_reset_postdata();

	endif;
	
	return $output;
}

/*
	* ShortCode
	* pm_appointment_book
	* pm_appointment_book_review
*/

function pm_appointment_book_review( $atts ) {
	global $wpdb;
	wp_enqueue_style( 'pm-ab-fe-appointment-book-style', PM_APPOINTMENT_BOOK_DIR.'modules/frontend/css/pm-appointment-book-fe.css', '', PM_APPOINTMENT_BOOK_VERSION, 'all' );
	$content = '';
	
	if(isset($_POST['booking_form_send'])):
		$options = get_option(PM_APPOINTMENT_BOOK_SETTINGS_OPTION);		
		$typageid = ($options ? $options['general']['thank_you_page'] : '');
		$typageurl = (!empty($typageid) ? get_permalink($typageid) : '#');
		$rvpageid = ($options ? $options['general']['review_page'] : '');
		$rvpageurl = (!empty($rvpageid) ? get_permalink($rvpageid) : '');
	
		$price = esc_html($_POST['booking_form_price']);
		$qty = (int) esc_html($_POST['booking_form_price_qty']);
		$total_price = $qty * $price;			
		//Register Appointment to Session
		$_POST['booking_form_price'] = $price;
		$_POST['booking_form_price_total'] = $total_price;
		$_SESSION['pmab'] = $_POST;
		$session = $_SESSION['pmab'];
		$_SESSION['pmab_status'] = 'pending';		
		
		$booking_email = $session['booking_form_email'];
		
		
		$content .= "<section id='pmab_booking_wrapper'>";
		// Checks if user is logged-in. if not then ask if user wants to create.
		if( !is_user_logged_in() ) {
			$content .= "<p>".esc_html(__('Seems like you are not logged-in. Creating an account lets you manage your bookings and you cancel them any time. ', 'pm-appointment-book')).
			sprintf(__('<a href="%s">Click here</a> to create one.', 'pm-appointment-book'), wp_registration_url()).
			"</p>";
		}
		$content .= pm_appointment_book_booking_details($session);
		
		if(email_exists($booking_email) && !is_user_logged_in() ) {
			$content .= "<p>".sprintf(__('The email you selected is already registered to another account. <a href="%s">Click here</a> to login.', 'pm-appointment-book'), wp_login_url())."</p>";
		} else {
			if( (isset($options['general']['anonymous_booking']) || is_user_logged_in()) ) {
				if( $session['booking_form_payment_method'] == 'paypal' ) {
					$paypal_data = pm_appointment_book_create_data($session);
					if($paypal_data['status'] == 'success'):
						if( $options['payments']['paypal_mode'] == 'sandbox') {
							$content .= "<p>".esc_html(__('You are currently using Paypal Sandbox.', 'pm-appointment-book'))."</p>";
						}
						$content .= "<p><a class='pmab_btn' href='{$paypal_data['link']}'>".esc_html(__('Pay with Paypal', 'pm-appointment-book'))."</a></p>";
					else:  
						$content .= "<p>".esc_html(sprintf(__('Error %s.', 'pm-appointment-book'), $paypal_data['message']))."</p>";
					endif;
				} else {
					$content .= "<p><a class='pmab_btn' href='{$typageurl}'?success=true>".esc_html(__('Proceed to checkout', 'pm-appointment-book'))."</a></p>";
				}
			} else {
				$content .= "<p>".sprintf(__('Sorry you need to create an account to proceed. <a href="%s">Click here</a> to create one.', 'pm-appointment-book'), wp_registration_url())."</p>";
			}
			
		}
		$content .= "</section>";
	else: 
		$content = "<p>".esc_html(__("Sorry. The page you are trying to access doesn't exist. ", "pm-appointment-book"))."</p>";
	endif;	
	return $content;
}

/*
	* ShortCode
	* pm_appointment_book
	* pm_appointment_book_thank_you
*/

function pm_appointment_book_thank_you( $atts ) {
	wp_enqueue_style( 'pm-ab-fe-appointment-book-style', PM_APPOINTMENT_BOOK_DIR.'modules/frontend/css/pm-appointment-book-fe.css', '', PM_APPOINTMENT_BOOK_VERSION, 'all' );
	global $wpdb;
	$output = '';
	$content = '';
	if(isset($_SESSION['pmab']) && isset($_SESSION['pmab_status'])) {
		$paypalPaymentID = '';
		$options = get_option(PM_APPOINTMENT_BOOK_SETTINGS_OPTION);		
		$session = $_SESSION['pmab'];
		$pmab_status = $_SESSION['pmab_status'];
		$booking_status = 'pending';
		
		/*
			* Process if Payment is made from Paypal or Free Booking
			* Process if Paypal payment is successful 
		*/
		if( $session['booking_form_payment_method'] == 'paypal' ) {
			$paypal_data = pm_appointment_book_create_data($_POST, 'execute');
			if( $paypal_data['status'] == 'success') {
				$paypalPaymentID = $paypal_data['message'];
				$booking_status = 'completed';
				
			} elseif( $paypal_data['status'] == 'error') {
				$pmab_status = 'error';
			} elseif( $paypal_data['status'] == 'cancelled') {
				$booking_status = 'cancelled';
				$pmab_status = 'error';
			} else {
				$booking_status = 'cancelled';
				$pmab_status = 'error';
			}
		} elseif( $session['booking_form_payment_method'] == 'free' ) {
			$booking_status = 'completed';
		} else {
			$booking_status = 'cancelled';
			$pmab_status = 'error';
			
		}
		
		$output .= "<section id='pmab_booking_wrapper'>";
		$output .= "<p>".esc_html(__('Thank you. Your appointment have been booked.', 'pm-appointment-book'))."</p>";
		$output .= pm_appointment_book_booking_details($session);
		$output .= "</section>";
			
		//Insert Post once
		if($pmab_status == 'pending'):
		
		
		/*
		$booking_email = $session['booking_form_email'];
		$user_id = username_exists( $booking_email );
		if ( !$user_id and email_exists($booking_email) == false ) {
			$random_password = wp_generate_password( $length=8, $include_standard_special_chars=false );
			//$user_id = wp_create_user( $booking_email, $random_password, $booking_email );
			$content .= "<p>".esc_html(__('Create new account?', 'pm-appointment-book'))."</p>";
		} else {
			$content .= "<p>".esc_html(__('User already Exist!', 'pm-appointment-book'))."</p>";
			//$random_password = __('User already exists.  Password inherited.');
		}
		*/
		$userid = get_current_user_id();
		$userid = ($userid == 0 ? 1 : $userid);
		// Gather post data.
		$details = array();
		foreach($session as $key => $value) {
			if(!is_array($value)) {
				$details[$key] = esc_html($value);
			} else {
				$details[$key] = $value;
			}
		}
		$my_post = array(
			'post_title'    => 'Appointment',
			'post_content'  => '',
			'post_status'   => $booking_status,
			'post_type' => 'pm-appointment',
			'post_author'   => $userid
		);
		$post_id = wp_insert_post( $my_post );
		if($post_id) {
			update_post_meta($post_id, '_appointment_details',$details);
			update_post_meta($post_id, '_appointment_status', 'completed');
			if($paypalPaymentID){
				update_post_meta($post_id, '_appointment_paypal_txn_id', $paypalPaymentID);
			}
			
			// Update Post Title
			$update_post = array(
			'ID'           => $post_id,
			'post_title'   => 'Appointment - '.$post_id
			);
			wp_update_post( $update_post );
			
			$time_array = $details['pm_ab_time'];
			foreach($time_array as $t) {
				$booking_date = date('Y-m-d' ,strtotime(esc_html($details['booking_form_date'])));
				$data = array(
					'postid'	=>	$post_id,
					'booking_date'	=> $booking_date,
					'time'	=>  $t
				);
				$insert = pm_appointment_book_add_booking($data);	
			}
			//Send Mail to Admin
			$mail_data = array();
			$mail_data['pid'] = $post_id;
			$mail_data['type'] = 'admin';
			$mail_data['user_email'] = $details['booking_form_email'];
			
			pm_appointment_book_send_mail($mail_data,$details);
			
			//Send Mail to User
			$mail_data = array();
			$mail_data['pid'] = $post_id;
			$mail_data['type'] = 'user';
			$mail_data['user_email'] = $details['booking_form_email'];
			pm_appointment_book_send_mail($mail_data,$details);
			$_SESSION['pmab_status'] = 'completed';
			unset($_SESSION['pmab']);
		}
		endif; //End Insert post	
		
	} else {
		$output = "<p>".esc_html(__("Sorry. The page you are trying to access doesn't exist. ", "pm-appointment-book"))."</p>";
	}
	return $output;
}



